//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrDimGray
#property indicator_color3  clrPaleVioletRed
#property indicator_color4  clrOrange
#property indicator_color5  clrLimeGreen
#property indicator_color6  clrLimeGreen
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int                DpoPeriod           = 14;
extern ENUM_APPLIED_PRICE DpoPrice            = PRICE_CLOSE;
extern double             DpoT3Smooth         = 5;
extern double             DpoT3SmoothHot      = 0.7;
extern bool               DpoT3SmoothOriginal = false;
extern int                MaPeriod            = 14;
extern ENUM_MA_METHOD     MaMethod            = MODE_SMA;
extern int                AtrPeriod           = 14;
extern double             AtrMultiplier       =  2;

//
//
//
//
//

double dpo[];
double dpoua[];
double dpoub[];
double slope[];
double atrUp[];
double atrDn[];
double ma[];

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,atrUp);
   SetIndexBuffer(1,ma);
   SetIndexBuffer(2,atrDn);
   SetIndexBuffer(3,dpo);
   SetIndexBuffer(4,dpoua);
   SetIndexBuffer(5,dpoub);
   SetIndexBuffer(6,slope);
   return(0);
}

//
//
//
//
//

int start()
  {
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   int shift = DpoPeriod/2+1;
      if (slope[limit]== 1) CleanPoint(limit,dpoua,dpoub);
      for(i=limit; i>=0; i--) dpo[i] = iT3(iMA(NULL,0,1,0,MODE_SMA,DpoPrice,i)-iMA(NULL,0,DpoPeriod,0,MODE_SMA,DpoPrice,i+shift),DpoT3Smooth,DpoT3SmoothHot,DpoT3SmoothOriginal,i);
      for(i=limit; i>=0; i--) 
      { 
         double atr = iATR(NULL,0,AtrPeriod,i);
            ma[i]    = iMAOnArray(dpo,0,MaPeriod,0,MaMethod,i);
            atrUp[i] = ma[i]+atr*AtrMultiplier;
            atrDn[i] = ma[i]-atr*AtrMultiplier;
            slope[i] = slope[i+1];
            dpoua[i] = EMPTY_VALUE;
            dpoub[i] = EMPTY_VALUE;
            if (dpo[i]>dpo[i+1]) slope[i] = 1;
            if (dpo[i]<dpo[i+1]) slope[i] =-1;
            if (slope[i] == 1) PlotPoint(i,dpoua,dpoub,dpo);
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

